<#
.SYNOPSIS
    Updates the external IP in the FTP site configuration settings in IIS
.DESCRIPTION
    Checks the current WAN IP address using ipinfo.io, and updates the FTP 'external IP' value as necessary
.EXAMPLE
    PS C:\> Update-FTPExternalIP 
.INPUTS
    Inputs (if any)
.OUTPUTS
    Custom object with current IP adddress, previous value listed in IIS, and a status to indicate if the value was updated
.NOTES
    Does not create a log, redirect output to a log file as necessary
#>
# Set up object for output
$Result = [PSCustomObject] @{
    Time = Get-Date
    IP = $null
    PreviousValue = $null
    Status = "Failed"
}

# Get external IP address
# https://gallery.technet.microsoft.com/scriptcenter/Get-ExternalPublic-IP-c1b601bb
$Result.ip = Invoke-RestMethod http://ipinfo.io/json | Select-Object -exp ip

# Get current value of property
$Result.PreviousValue = (Get-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST'  -filter "system.applicationHost/sites/siteDefaults/ftpServer/firewallSupport" -name "externalIp4Address").Value

If ($Result.ip -ne $Result.PreviousValue) {
    Try {
            # Generated by IIS
        Set-WebConfigurationProperty -pspath 'MACHINE/WEBROOT/APPHOST'  -filter "system.applicationHost/sites/siteDefaults/ftpServer/firewallSupport" -name "externalIp4Address" -value $Result.ip
        $Result.Status = "Updated IP in configuration"
    }
    Catch {
        $Result.Status = "Failed"
    }
}
Else {
    $Result.Status = "No changes required"
}
Return $Result